/*
 * @Author: 祝玲云
 * @Date: 2021-06-25 14:01:20
 * @LastEditTime: 2021-06-25 14:01:20
 * @LastEditors: Please set LastEditors
 * @Description: 插件统一入口
 * @FilePath: \xs-plugins\src\lib\index.js
 */

const path = require('path')
const RouterPlugins = require('./router')
const ApiPlugins = require('./api')
const MenuPlugin = require('./menu')

// 自动生成插件默认配置项
const plugins = {
    autoPath: 'src/automatically',  // 文件生成位置
    entry: '', // 遍历文件夹的位置
}

class IndexPlugins {
    constructor(options) {
        plugins.entry = path.join('/src/modules/' + options.moduleConfig.CUR_MODULES + '/')
        this.options = options
    }
    // 自动化插件统一入口
    async apply (compiler) {
        // 自动生成路由
       let router = await new RouterPlugins({...plugins, ...this.options}).apply(compiler)
        // 自动生成api
       let api = await new ApiPlugins({...plugins, ...this.options}).apply(compiler)
       // 菜单权限 (等路由 + api 生成后才能生成)
       new MenuPlugin({...plugins, ...this.options, router, api}).apply(compiler)
    }
}

module.exports = IndexPlugins